/* compile.c
	P.Chongstitvatana
	19 Aug 97
	1 Sept 97
	3 Apr 2001  start project RZ
	1 Jan 2002  generate s2 code
	27 Sept 2010   begin project rz3, generate parse-tree

*/

#include "compile.h"

extern int pass(void);		/* parse.c */

//FILE *FO;					/* output file */
/*
void strcat2(char *s1, char *s2, char *s3){
	strcpy(s1,s2);
	strcat(s1,s3);
}
*/
void prolog(void){
	int a;
	a = putSym("main",tyFUNCTION,0,0);
	ypush(MARK);
	mylex();
}
// search symbol table for Function and show it
void showParseTree(void){
	extern int nsym;
	int i;
	for(i=1; i<=nsym; i++)
		if(getType(i) == tyFUNCTION){
			printList(getRef(i));
			printf("\n");
		}
}
void showGlobal(void){
	extern int nsym;
	int i, ty;
	for(i=1; i<=nsym; i++){
		ty = getType(i);
		if(ty == tySCALAR || ty == tyVECTOR){
			printf("%s type %d ref %d\n",getName(i),ty,getRef(i));
		}
	}
}

void testlex(void){
	mylex();
	while(tok != tkEOF){
		prtoken(tok);
		printf(" ");
		mylex();
	}
}


extern int cnt;

int main( int argc, char *argv[] ){
	string source, code, list, iasm, name;
	char *fname;

	if( argc < 2 ) {
	printf("usage : compile source\n");
	exit(-1);
	}
	strcpy(source,argv[1]);
	strcpy(name,source);
	fname = strtok(name,".");
	if( fname == NULL ) fname = name;
//	strcat2(code,fname,".out");
//	strcat2(list,fname,".lst");
//	strcat2(iasm,fname,".s2");

//	initCharType();
	readinfile(source);
//	getC();
	testlex();
/*
	prolog();
	pass();
//	reName();
	showParseTree();
	showGlobal();
	eval(getRef(1));				// eval main
//  dumpSymTab();
*/
/*
	FO = fopen(iasm,"wt");
	rzloop2();
	fclose(FO);

	FO = fopen(code,"wb");
	writeHead(FO,CP,DS);
	dumpCode();
	fclose(FO);

	FO = fopen(list,"wt");
	showCode();
	fclose(FO);
	return 0;
*/
}

