// parser Som-c generated from parse-grammar-c.txt 1 Oct 2010
// global: Nlv, tok, tokvalue, nenum

int top(void);
int fundef(void);
int macro(void);
int args(void);
int local(void);
int ex(void);
int exs(void);
int ex1(void);
int exelse(void);
int elist(void);
int elist2(void);
int caselist(void);
int label(void);
int ex0(void);
int terms(void);
int term(void);
int aspec(void);
int alist(void);
int aitem(void);
int tuple(void);
int tuples(void);
int mod(void);
int bop(void);

int top(void){
	switch(tok){
	case tkTO:
		mylex();
		commit(fundef());
		return 1;
	case tkCOLON:
		mylex();
		commit(macro());
		return 1;
	default:
		if( ex() ){
			return 1;
		}
	}
	return 0;
}
int fundef(void){
	if( tok == tkIDEN ){
		ypush(tokvalue);
		mylex();
		commit(args());
		setfname(tyFUNC);
		expect(tkEQ, "missing tkEQ");
		mylex();
		commit(ex());
		dofun(tkTO);
		return 1;
	}
	return 0;
}
int macro(void){
	if( tok == tkIDEN ){
		ypush(tokvalue);
		mylex();
		commit(args());
		setfname(tyMAC);
		expect(tkEQ, "missing tkEQ");
		mylex();
		commit(ex());
		dofun(tkCOLON);
		return 1;
	}
	return 0;
}
int args(void){
	while( tok == tkIDEN ){
		enterLocal(tokvalue);
		mylex();
	}
	if( tok == tkBAR ){
		ypush(Nlv);
		mylex();
		commit(local());
		return 1;
	}
	ypush(Nlv);
	return 1;
}
int local(void){
	while( tok == tkIDEN ){
		enterLocal(tokvalue);
		mylex();
	}
	return 1;
}
int ex(void){
	if( tok == tkBB ){
		ypush(MARK);
		mylex();
		commit(exs());
		expect(tkBE, "missing tkBE");
		doblock();
		mylex();
		return 1;
	}
	if( ex1() ){
		return 1;
	}
	return 0;
}
int exs(void){
	while( ex1() ){
	}
	return 1;
}
int ex1(void){
	switch(tok){
	case tkIF:
		mylex();
		commit(ex0());
		commit(ex());
		commit(exelse());
		doif();
		return 1;
	case tkWHILE:
		mylex();
		commit(ex0());
		commit(ex());
		dowhile();
		return 1;
	case tkFOR:
		mylex();
		expect(tkIDEN, "missing tkIDEN");
		ypush(tokvalue);
		mylex();
		commit(ex0());
		commit(ex0());
		commit(ex());
		dofor();
		return 1;
	case tkCASE:
		mylex();
		commit(ex0());
		expect(tkBB, "missing tkBB");
		ypush(MARK);
		mylex();
		commit(caselist());
		expect(tkBE, "missing tkBE");
		docase();
		mylex();
		return 1;
	case tkENUM:
		mylex();
		expect(tkBB, "missing tkBB");
		mylex();
		commit(elist());
		expect(tkBE, "missing tkBE");
		ypush(NIL);
		mylex();
		return 1;
	case tkBREAK:
		ypush(newatom(OPER, tkBREAK));
		mylex();
		return 1;
	default:
		if( exas() ){
			return 1;
		}
	}
	return 0;
}
int exelse(void){
	if( tok == tkELSE ){
		mylex();
		commit(ex());
		ypush(MARK);
		return 1;
	}
	return 1;
}
int elist(void){
	if( tok == tkNUMBER ){
		nenum = tokvalue;
		mylex();
		commit(elist2());
		return 1;
	}
	if( elist2() ){
		return 1;
	}
	return 0;
}
int elist2(void){
	while( tok == tkIDEN ){
		doenum();
		mylex();
	}
	return 1;
}
int caselist(void){
	while( label() ){
		expect(tkCOLON, "missing tkCOLON");
		mylex();
		commit(ex());
	}
	if( tok == tkELSE ){
		donum(-1);
		mylex();
		expect(tkCOLON, "missing tkCOLON");
		mylex();
		commit(ex());
		return 1;
	}
	return 1;
}
int label(void){
	if( tok == tkNUMBER ){
		donum(tokvalue);
		mylex();
		return 1;
	}
	if( tok == tkIDEN ){
		dolabel();
		mylex();
		return 1;
	}
	return 0;
}
int ex0(void){
	if( term() ){
		commit(terms());
		return 1;
	}
	return 0;
}
int terms(void){
	while( bop() ){
		commit(term());
		dobop();
	}
	return 1;
}
int term(void){
	int a;
	switch(tok){
	case tkNUMBER:
		donum(tokvalue);
		mylex();
		return 1;
	case tkSTRING:
		dostring();
		mylex();
		return 1;
	case tkIDEN:
		a = tokvalue;
		mylex();
		doiden(a);
		return 1;
	case tkNOT:
		mylex();
		commit(ex0());
		douop(tkNOT);
		return 1;
	case tkARRAY:
		mylex();
		commit(aspec());
		return 1;
	case tkSYSCALL:
		mylex();
		commit(tuple());
		dosys();
		return 1;
	case tkLPAREN:
		mylex();
		commit(ex0());
		expect(tkRPAREN, "missing tkRPAREN");
		mylex();
		return 1;
	}
	return 0;
}
int aspec(void){
	int a;
	if( tok == tkBB ){
		a = array_0;
		mylex();
		commit(alist());
		expect(tkBE, "missing tkBE");
		ypush(newatom(ADS, a));
		mylex();
		return 1;
	}
	if( ex0() ){
		douop(tkARRAY);
		return 1;
	}
	return 0;
}
int alist(void){
	while( aitem() ){
	}
	return 1;
}
int aitem(void){
	switch(tok){
	case tkNUMBER:
		M[newdata] = tokvalue;
		mylex();
		return 1;
	case tkSTRING:
		akeepStr();
		mylex();
		return 1;
	case tkIDEN:
		akeepIden();
		mylex();
		return 1;
	}
	return 0;
}
int tuple(void){
	if( tok == tkBB ){
		mylex();
		expect(tkNUMBER, "missing tkNUMBER");
		ypush(MARK);
		donum(tokvalue);
		mylex();
		commit(tuples());
		expect(tkBE, "missing tkBE");
		mylex();
		return 1;
	}
	return 0;
}
int tuples(void){
	while( ex0() ){
	}
	return 1;
}
int mod(void){
	if( tok == tkLBRACKET ){
		mylex();
		commit(ex0());
		expect(tkRBRACKET, "missing tkRBRACKET");
		dovec();
		mylex();
		return 1;
	}
	return 1;
}
int bop(void){
	switch(tok){
	case tkPLUS:
		ypush(tok);
		mylex();
		return 1;
	case tkMINUS:
		ypush(tok);
		mylex();
		return 1;
	case tkSTAR:
		ypush(tok);
		mylex();
		return 1;
	case tkSLASH:
		ypush(tok);
		mylex();
		return 1;
	case tkAND:
		ypush(tok);
		mylex();
		return 1;
	case tkBAR:
		ypush(tok);
		mylex();
		return 1;
	case tkCARET:
		ypush(tok);
		mylex();
		return 1;
	case tkEQEQ:
		ypush(tok);
		mylex();
		return 1;
	case tkNE:
		ypush(tok);
		mylex();
		return 1;
	case tkLT:
		ypush(tok);
		mylex();
		return 1;
	case tkLE:
		ypush(tok);
		mylex();
		return 1;
	case tkGE:
		ypush(tok);
		mylex();
		return 1;
	case tkGT:
		ypush(tok);
		mylex();
		return 1;
	case tkMOD:
		ypush(tok);
		mylex();
		return 1;
	case tkGTGT:
		ypush(tok);
		mylex();
		return 1;
	case tkLTLT:
		ypush(tok);
		mylex();
		return 1;
	}
	return 0;
}
